//
//  WebConnectController.m
//
//  Created by Pedro Anisio Silva <pedroanisio@me.com> on 10/26/10.
//  Copyright 2010 parsec.digital All rights reserved.
//

#import "WebConnectController.h"
#import "ASIHTTPRequest.h"
#import "ASIFormDataRequest.h"
#import "Reachability.h"

//DEFINE WHAT KEY TO USE IN NSDEFAULTS
#define WEB_CONNECT_KEY @"webdata"

@implementation WebConnectController

+(void) saveToUserDefaults:(id)value atKey:(NSString *)key {
	
	NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
	
	if (standardUserDefaults) {
		[standardUserDefaults setObject:value forKey:key];
		[standardUserDefaults synchronize];
	}
}

+(id) retrieveFromUserDefaults:(NSString *)key {
	NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
	NSString *val = nil;
	
	if (standardUserDefaults) 
		val = [standardUserDefaults objectForKey:key];
	
	return val;
}

+(int) countWebData {
	NSArray *countArray = (NSArray*)[WebConnectController retrieveFromUserDefaults:WEB_CONNECT_KEY];
	return [countArray count];
}

+(void) addWebData:(NSDictionary *) package {
	
	NSMutableArray *addTempArray = [[NSMutableArray alloc] init];
	
	if ([WebConnectController retrieveFromUserDefaults:WEB_CONNECT_KEY] != nil) {
		
		[addTempArray addObjectsFromArray:[WebConnectController retrieveFromUserDefaults:WEB_CONNECT_KEY]];
		
	}
	
	[addTempArray addObject:[package retain]];
	[WebConnectController saveToUserDefaults:addTempArray atKey:WEB_CONNECT_KEY];
	[addTempArray release];
	
}

+(void) runPrivate {
		
	if ([WebConnectController retrieveFromUserDefaults:WEB_CONNECT_KEY] != nil) {
				
		NSMutableArray *addTempArray = [[NSMutableArray alloc] init];
		[addTempArray addObjectsFromArray:[WebConnectController retrieveFromUserDefaults:WEB_CONNECT_KEY]];
		
		int numberOfWebData = 0;
		
		// INCIANDO ITERACAO NO PAYLOAD
		
		while (numberOfWebData < [addTempArray count]) {
						
			//INICIANDO ESVAZIAMENTO DA PILHA DO TIPO LIFO
			
			NSDictionary *tempDictionary = [NSDictionary dictionaryWithDictionary:[addTempArray lastObject]];
			
			if([[tempDictionary objectForKey:@"action"] isEqualToString:@"POST"]) {
				
				// IMPLEMENTADO
				
				NSURL *url = [NSURL URLWithString:[tempDictionary objectForKey:@"urlToREST"]];
				NSDictionary *parametersDict = [NSDictionary dictionaryWithDictionary:[tempDictionary objectForKey:@"parameters"]];				
				
				ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:url];				
				
				int paramIterator = 0;
				
				NSArray *allParametersKeys = [parametersDict allKeys];
				
				while (paramIterator < [allParametersKeys count]) {
										
					[request setPostValue:[parametersDict objectForKey:[allParametersKeys objectAtIndex:paramIterator]] forKey:[allParametersKeys objectAtIndex:paramIterator]];	
					
					paramIterator++;
					
				}
				
				[request startSynchronous];
				NSError *error = [request error];
				if (!error) {
					[addTempArray removeLastObject];
					[WebConnectController saveToUserDefaults:addTempArray atKey:WEB_CONNECT_KEY];
					//NSLog(@"Sucesso, vou remover...");					
				}
				
			} else {
				// TODO: implementar outros métodos depois: GET, PUT, DELETE, OPTIONS, etc.. 
			}
			
			
			numberOfWebData++;		
			
		}
		[addTempArray release];
	}	
		
}

+ (void)verificaReachability {
	
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	Reachability *hostReachability = [Reachability reachabilityWithHostName:@"www.apple.com"];
	NetworkStatus network = [hostReachability currentReachabilityStatus];
	
	// se o host estiver acessível
	if (network != NotReachable) {
		[WebConnectController runPrivate];
	}
	
	[pool release];
	
}

+(void) flushWebData {
	
	[NSThread detachNewThreadSelector:@selector(verificaReachability) toTarget:[WebConnectController class] withObject:nil];
	
}

@end
